"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ArtifactsTree = void 0;
const react_1 = __importStar(require("react"));
const classnames_1 = __importDefault(require("classnames"));
const evangelist_elements_icon_1 = require("@teambit/evangelist.elements.icon");
const ui_foundation_ui_tree_tree_node_1 = require("@teambit/ui-foundation.ui.tree.tree-node");
const ui_foundation_ui_tree_drawer_1 = require("@teambit/ui-foundation.ui.tree.drawer");
const ui_foundation_ui_tree_file_tree_1 = require("@teambit/ui-foundation.ui.tree.file-tree");
const component_ui_artifacts_queries_use_component_artifacts_1 = require("@teambit/component.ui.artifacts.queries.use-component-artifacts");
const base_react_navigation_link_1 = require("@teambit/base-react.navigation.link");
const base_ui_graph_tree_tree_context_1 = require("@teambit/base-ui.graph.tree.tree-context");
const design_ui_skeletons_sidebar_loader_1 = require("@teambit/design.ui.skeletons.sidebar-loader");
const ui_foundation_ui_tree_folder_tree_node_1 = require("@teambit/ui-foundation.ui.tree.folder-tree-node");
const artifact_file_node_clicked_1 = require("./artifact-file-node-clicked");
const artifacts_tree_module_scss_1 = __importDefault(require("./artifacts-tree.module.scss"));
function ArtifactsTree({ getIcon, host, componentId, drawerName, drawerOpen, onToggleDrawer, }) {
    const [selected, setSelected] = (0, react_1.useState)();
    const location = (0, base_react_navigation_link_1.useLocation)();
    const { data: artifacts = [], loading } = (0, component_ui_artifacts_queries_use_component_artifacts_1.useComponentArtifacts)(host, componentId.toString());
    const hasArtifacts = artifacts.length > 0;
    const [files, artifactFilesTree] = (0, react_1.useMemo)(() => {
        const _files = (hasArtifacts &&
            artifacts.flatMap((artifact) => artifact.files.map((file) => (Object.assign(Object.assign({}, file), { id: `${artifact.taskName}/${artifact.name}/${file.path}` }))))) ||
            [];
        const _artifactFilesTree = _files.map((file) => file.id);
        return [_files, _artifactFilesTree];
    }, [artifacts]);
    const payloadMap = (hasArtifacts &&
        artifacts.reduce((accum, next) => {
            if (!accum.has(next.taskName))
                accum.set(`${next.taskName}/`, { open: false });
            return accum;
        }, new Map())) ||
        new Map();
    const currentHref = (location === null || location === void 0 ? void 0 : location.pathname) || '';
    const getHref = () => currentHref;
    const widgets = (0, react_1.useMemo)(() => [generateWidget(files || [])], [files]);
    if (!hasArtifacts)
        return null;
    return (react_1.default.createElement(ui_foundation_ui_tree_drawer_1.DrawerUI, { isOpen: drawerOpen, onToggle: onToggleDrawer, name: drawerName, contentClass: artifacts_tree_module_scss_1.default.artifactsPanelCodeDrawerContent, className: (0, classnames_1.default)(artifacts_tree_module_scss_1.default.artifactsPanelCodeTabDrawer, drawerOpen && artifacts_tree_module_scss_1.default.openDrawer) },
        loading && react_1.default.createElement(design_ui_skeletons_sidebar_loader_1.ComponentTreeLoader, null),
        loading || (react_1.default.createElement(ui_foundation_ui_tree_file_tree_1.FileTree, { getIcon: getIcon, getHref: getHref, files: artifactFilesTree, widgets: widgets, payloadMap: payloadMap, TreeNode: FileTreeNode, selected: selected, onTreeNodeSelected: (id, e) => {
                setSelected(id);
                (0, artifact_file_node_clicked_1.fileNodeClicked)(files, 'new tab')(e, { id });
            } }))));
}
exports.ArtifactsTree = ArtifactsTree;
function generateWidget(files) {
    return function Widget({ node }) {
        const id = node === null || node === void 0 ? void 0 : node.id;
        const artifactFile = files.find((file) => file.id === id);
        if (artifactFile) {
            return (react_1.default.createElement("div", { className: artifacts_tree_module_scss_1.default.artifactWidgets },
                react_1.default.createElement(evangelist_elements_icon_1.Icon, { className: artifacts_tree_module_scss_1.default.icon, of: "download", onClick: (e) => {
                        (0, artifact_file_node_clicked_1.fileNodeClicked)(files, 'download')(e, node);
                    } })));
        }
        return null;
    };
}
function FileTreeNode(props) {
    var _a, _b;
    const { node } = props;
    const fileTreeContext = (0, ui_foundation_ui_tree_file_tree_1.useFileTreeContext)();
    const { selected, onSelect } = (0, react_1.useContext)(base_ui_graph_tree_tree_context_1.TreeContext);
    const href = (_a = fileTreeContext === null || fileTreeContext === void 0 ? void 0 : fileTreeContext.getHref) === null || _a === void 0 ? void 0 : _a.call(fileTreeContext, node);
    const widgets = fileTreeContext === null || fileTreeContext === void 0 ? void 0 : fileTreeContext.widgets;
    const icon = (_b = fileTreeContext === null || fileTreeContext === void 0 ? void 0 : fileTreeContext.getIcon) === null || _b === void 0 ? void 0 : _b.call(fileTreeContext, node);
    if (!(node === null || node === void 0 ? void 0 : node.children)) {
        return (react_1.default.createElement(ui_foundation_ui_tree_tree_node_1.TreeNode, Object.assign({}, props, { className: artifacts_tree_module_scss_1.default.link, onClick: onSelect && ((e) => onSelect(node.id, e)), href: href, isActive: (node === null || node === void 0 ? void 0 : node.id) === selected, icon: icon, widgets: widgets })));
    }
    return react_1.default.createElement(ui_foundation_ui_tree_folder_tree_node_1.FolderTreeNode, Object.assign({}, props));
}
//# sourceMappingURL=artifacts-tree.js.map